import { Actions } from './types'
interface EntitiesState<Entity = any> {
  ids: string[]
  entities: Record<string, Entity>
}
export declare const entitiesActions: {
  addOne: (entity: any) => any
  addMany: (entities: any[]) => any[]
  updateOne: (entity: any) => any
  updateMany: (entities: any[]) => any[]
  upsertOne: (entity: any) => any
  upsertMany: (entities: any[]) => any[]
  setOne: (entity: any) => any
  setMany: (entities: any[]) => any[]
  setAll: (entities: any[]) => any[]
  removeOne: (entity: any) => any
  removeMany: (entities: any[]) => any[]
  removeAll: () => any
}
export declare const entitiesReducer: (
  actions: Actions<string, typeof entitiesActions>,
  {
    processEntity,
    selectId,
    sortComparer,
    updateComparer,
  }?: {
    processEntity?: <T>(entity: T) => T
    selectId?: (entity: any) => any
    sortComparer?: (a: any, b: any) => number
    updateComparer?: <T_1>(a: T_1, b: T_1) => boolean
  },
) => {
  [x: string]:
    | ((
        state: any,
        {
          payload,
        }: {
          payload: any
        },
      ) => {
        entities: {
          [k: string]: any
        }
        ids: any
      })
    | ((state: any) => any)
}
export declare const selectEntities: <Entity>(state: EntitiesState<Entity>) => Entity[]
export declare const selectEntityById: <Entity>(state: EntitiesState<Entity>, id: any) => Entity
export declare const selectEntitiesTotal: (state: EntitiesState) => number
export {}
